<?php
$bdd = mysqli_connect($server,$user,$pwd,$base);
echo '<p style="text-align:center;font-size:1.4em;padding-top:5px;">Intégration des paramètres par défaut dans la base de données...</p>'; flush(); ob_flush();
// Puis les paramétrages par défaut :
// -- Contenu de la table `preidlog_parametres`
$param_insert = "INSERT INTO `preidlog_parametres` (`param_id`, `param_nom`, `valeur`, `comments`) VALUES
(1, 'version_log', '4.14', 'Numéro de version courante du logiciel.'),
(2, 'version_bdd', '0.40', 'Version courante de la base de données.'),
(3, 'info_menu', '1', 'Option d''une infobulle sur les menus du logiciel.'), 
(4, 'savoirs', 'A1E0P0', 'Paramétrage des savoirs utilisés dans le module d''évaluation (A pour APD, E pour EMI, P pour PER - 0 pour désactivé, 1 pour activé).'),
(5, 'freq_seuilnbi', '0', 'Seuil maximal du nombre d''inscrits.'),
(6, 'freq_creneausuiv', '0', 'Passage anticipé à l''heure suivante pour les inscriptions.'),
(7, 'freq_multiinscrit', '0', 'Option d''inscription sur plusieurs créneaux.'),
(8, 'freq_inscritbutton', '0', 'Choix d''affichage des boutons de sortie et exclusion, ainsi que des retards, sur les droits non administrateurs.'),
(9, 'freq_seuilreaci', 'alert', 'Réaction lorsque le seuil maximal du nombre d''inscrits est atteint.'),
(10, 'freq_seuilnbr', '0', 'Seuil maximal du nombre de réservations.'),
(11, 'freq_seuilreacr', 'alert', 'Réaction lorsque le seuil maximal du nombre de réservations est atteint.'),
(12, 'freq_ordreaff', 'div', 'Gestion de l''ordre d''affichage des inscriptions et réservations.'),
(13, 'freq_crendef', 'suivant', 'Choix du créneau de réservation par défaut.'),
(14, 'freq_resactiv', '0', 'Option de précision de l''activité lors de la réservation.'),
(15, 'freq_crprechoix', '0h', 'Autorisation ou non d''afficher les inscrits du créneau précédent, et emplacement de l''affichage.'), 
(16, 'freq_crenchoix', '0', 'Autorisation ou non du choix du créneau de réservation par l''usager.'), 
(17, 'freq_cienchoix', '0', 'Autorisation ou non du choix du créneau d''inscription.'), 
(18, 'freq_classe', '1', 'Possibilité d''inscrire par affichage de classe.'),
(19, 'freq_grappes', '0', 'Option de gestion des inscriptions par ensembles ou grappes d''élèves.'),
(20, 'freq_passages', '0', 'Option de gestion des simples passages en fréquentation.'),
(21, 'freq_inscritpronote', '0', 'Option d''inscription par copié/collé depuis Pronote.'),
(22, 'freq_appel', '1:1', 'Option de signalisation d''appel en consultation de la fréquentation.'),
(23, 'freq_chgtactiv', '0', 'Possibilité d''opérer des modifications dans le journal.'),
(24, 'freq_jhors', '0', 'Option de visualisation des heures d''inscriptions et de sorties dans le journal.'),
(25, 'freq_verractiv', '0', 'Option de verrouillage de l''activité par défaut.'), 
(26, 'freq_verrespace', '0', 'Option de verrouillage de l''espace par défaut.'),
(27, 'freq_vision_espaces_ins', '0', 'Option de visibilité du nombre d''inscrits par espace.'),
(28, 'freq_consultactiv', '1', 'Option de visualisation des activités en consultation.'), 
(29, 'freq_statsniv', '', 'Gestion des niveaux concernés dans l''établissement.'), 
(30, 'freq_statsniv_persoc', '', 'Gestion des regroupements personnalisés (caractères).'),
(31, 'freq_statsniv_person', '', 'Gestion des regroupements personnalisés (noms).'),
(32, 'freq_statcren_seuil', '20000', 'Option d''ajustement du seuil de séparation des stats par créneau.'),
(33, 'freq_sigb', 'non', 'Option d''importation des retards de prêts depuis PMB ou BCDI.'),
(34, 'freq_retards_ordre', 'div', 'Ordre d''affichage des retards de prêts par défaut.'), 
(35, 'freq_retards_bip', '0', 'Choix d''un avertissement sonore lors des inscriptions au sujet des retards.'),
(36, 'freq_reseleve', '0', 'Option de réservation par chaque élève avec son code.'),
(37, 'freq_reseleve_mdp', '0', 'Mot de passe pour la réservation par chaque élève avec son code.'),
(38, 'freq_reseleve_esp', '0', 'Option de réservation à distance par espaces.'),
(39, 'freq_reseleve_activ', '0', 'Option de précision de l''activité lors de la réservation à distance.'),
(40, 'freq_reseleve_dureemax', '0', 'Option de durée maximale pour la réservation à distance (en jours).'),
(41, 'freq_res_dureemax', '0', 'Option de durée maximale pour la réservation (en jours).'),
(42, 'freq_resblockevent', '0', 'Bloquage des réservations sur des événements.'),
(43, 'freq_resprintedt', '0', 'Affichage des EDT en réservation à distance.'),
(44, 'freq_resref_date', '0', 'Nombre de jours pour l''automatisation de période de refus de réservation.'),
(45, 'freq_excluopt', '0', 'Option de gestion des raisons et durées des exclusions.'),
(46, 'freq_excluopt_raisons', '0', 'Option de gestion des raisons des exclusions.'),
(47, 'freq_excluopt_signal', '0', 'Option de signalement des exclusions.'),
(48, 'freq_excluopt_signalduree', '0', 'Durée par défaut de signalement des exclusions.'),
(49, 'freq_excluopt_exc', '0', 'Option d''exclusions sur la durée.'),
(50, 'freq_excluopt_excduree', '0', 'Durée par défaut des exclusions.'),
(51, 'freq_excluopt_limit', '0', 'Option de gestion de limitations d''usages.'),
(52, 'freq_excluopt_limitduree', '0', 'Durée par défaut des limitations.'),
(53, 'freq_excluopt_activs', 'TOUTES', 'Activités concernées par une exclusion, par défaut.'),
(54, 'freq_notif_opt', '0', 'Option de notification de visites.'),
(55, 'freq_notif_nb', '100', 'Nombre de visites pour la notification de visites.'),
(56, 'barcodes_txt', 'IDLOG', 'Texte choisi pour le début du code élève.'),
(57, 'barcodes_int', '9', 'Nombre de chiffres pour le code élève.'),
(58, 'edt_coloration', 'niv', 'Choix du système de colorisation, entre niveaux et codes.'),
(59, 'edt_crencolors', '#EEEEEE#D0CCC2#7D7777#7D7777', 'Couleurs pour les créneaux libres, créneaux fermés avec ou sans texte, en-tête.'),
(60, 'edt_openmsg', '-', 'Message donné quand un créneau est libre dans l''emploi du temps.'),
(61, 'edt_brikverr', '1', 'Option de déverrouillage des briques des jours précédents.'),
(62, 'edt_brik_creadesactiv', '0', 'Option de désactivation des briques dans la page de création des EDT.'),
(63, 'edt_userevent', '0', 'Gestion d''emplois du temps multiples.'),
(64, 'edt_duplicate', '0', 'Option de duplication des emplois du temps.'),
(65, 'edt_imgmode', 'spe', 'Option d''image générique ou d''images spécifiques.'),
(66, 'edt_imgnb', '20', 'Nombre maximal d''images spécifiques stockées.'),
(67, 'edt_msgopt', '0;1.8;#000', 'Option de message sous l''emploi du temps.'),
(68, 'edt_msg', '', 'Contenu du message sous l''emploi du temps.'),
(69, 'edt_titopt', '0;1.8;#000;0', 'Option de titre sur l''emploi du temps.'),
(70, 'edt_tit', '', 'Contenu du titre sur l''emploi du temps.'),
(71, 'edt_imgajust', '0;-38;0;0;0;0', 'Paramètres pour ajustement de l''image EDT extraite.'),
(72, 'eval_degres', '4', 'Choix du nombre de degrés d''évaluation, à trois ou quatre.'),
(73, 'eval_perso', 'niveau', 'Choix d''une évaluation par niveau ou globale sur la grille personnalisée.'),
(74, 'fuseau', 'Europe/Paris', 'Fuseau horaire pour la zone.'),
(75, 'colors_stats_array', '#FF9900#99FF00#CCFFFF#FF66FF#CC6600#FFFF33#99CC66#003399#9900FF#FF0033#CCCC00#66CC66#CCFFFF#333366#CC99CC#330033#FF6666#993300#33CC33#3399FF', 'Couleurs disponibles pour les graphiques, personnalisables.'),
(76, 'barcodes_default_modeleve', 'default', 'Choix du modèle de code-barres pour les élèves par défaut.'),
(77, 'espaces_gestion', '0', 'Gestion de différents espaces.'),
(78, 'espaces_first', 'CDI', 'Nom de l''espace principal en cas de gestion de différents espaces.'),
(79, 'espaces_first_resamulti', '1', 'Option de réservation dans le premier espace, si plusieurs espaces.'),
(80, 'espaces_first_resadistmulti', '1', 'Option de réservation à distance dans le premier espace, si plusieurs espaces.'),
(81, 'mail_method', 'php', 'Choix de la méthode pour envoi de mails.')";
mysqli_query($bdd,$param_insert);

// Contenu de la table `preidlog_barcodes`
mysqli_query($bdd,"INSERT INTO preidlog_barcodes (nom, typusage, format, nbwidth, nbheight, type, margextg, margextd, margexth, margextb, margintg, margintd, marginth, margintb, textup, textspe, textupsize, fontsize) VALUES ('default', 'eleve', 'P', '5', '13', 'C128B', '10', '10', '11', '10', '4', '4', '6', '6', '1', '', '3', '6')");

// Contenu de la table `preidlog_freqactiv`
$freqactiv_insert = "INSERT INTO `preidlog_freqactiv` (`activ_id`, `code_activ`, `nom_activ`, `activ_activ`, `default_activ`, `consult_activ`) VALUES
(1, 'ZERO', '', 0, 0, 0),
(2, 'SEAN', 'Séance', 1, 1, 1),
(3, 'ETUD', 'Etude', 1, 0, 1)";
mysqli_query($bdd,$freqactiv_insert);

// Contenu de la table `preidlog_edtcode`
$edtcode_insert = "INSERT INTO `preidlog_edtcode` (`code_id`, `code`, `nom`, `activ_code`, `default_code`, `bgcolor_code`) VALUES
(1, 'Info-Doc', 'Information-documentation', 1, 1, '#FF9900'),
(2, 'EMI', 'Education aux médias et à l''information', 1, 0, '#99FF00'),
(3, 'IRD', 'Initiation à la recherche documentaire', 1, 0, '#CCFFFF'),
(4, 'EAM', 'Education aux médias', 1, 0, '#FF66FF'),
(5, 'EMC', 'Enseignement moral et civique', 1, 0, '#CC6600'),
(6, 'Hist-Géo', 'Histoire-Géographie', 1, 0, '#FFFF33'),
(7, 'Techno', 'Technologie', 1, 0, '#99CC66'),
(8, 'SVT', 'Science de la vie et de la terre', 1, 0, '#1E7FCB'),
(9, 'P-C', 'Physique-Chimie', 1, 0, '#9900FF'),
(10, 'Fr.', 'Français', 1, 0, '#FF0033'),
(11, 'LVE', 'Langues vivantes étrangères', 1, 0, '#CCCC00'),
(12, 'Maths', 'Mathématiques', 1, 0, '#66CC66'),
(13, 'HDA', 'Histoire des Arts', 1, 0, '#EFD242'),
(14, 'Arts pla.', 'Arts plastiques', 1, 0, '#FFF48D'),
(15, 'AP', 'Accompagnement personnalisé', 1, 0, '#CC99CC'),
(16, 'EPI', 'Enseignement pratique interdisciplinaire', 1, 0, '#E6E697'), 
(17, 'Avenir', 'Parcours Avenir', 1, 0, '#FF6666'),
(18, 'Santé', 'Parcours Santé', 1, 0, '#F4C430')";
mysqli_query($bdd,$edtcode_insert);

// Contenu de la table `preidlog_edtnivcolor`
$edtnivcolor_insert = "INSERT INTO `preidlog_edtnivcolor` (`id`, `niveau`, `bgcolor`) VALUES
('1', '6', '#F5A9A9'),
('2', '5', '#F5D0A9'),
('3', '4', '#E1F5A9'),
('4', '3', '#BCF5A9'),
('5', '2', '#A9F5BC'),
('6', '1', '#A9F5F2'),
('7', 't', '#A9A9F5'),
('8', 'a', '#E2A9F3'),
('9', 'r', '#E6E6E6')";
mysqli_query($bdd,$edtnivcolor_insert);

// Contenu de la table `preidlog_hordemis`
$hordemis_insert = "INSERT INTO `preidlog_hordemis` (`id`, `demijour`, `statut`) VALUES
('1', 'lu_am', '1'),
('8', 'lu_pm', '1'),
('2', 'ma_am', '1'),
('9', 'ma_pm', '1'),
('3', 'me_am', '1'),
('10', 'me_pm', '1'),
('4', 'je_am', '1'),
('11', 'je_pm', '1'),
('5', 've_am', '1'),
('12', 've_pm', '1'),
('6', 'sa_am', '1'),
('13', 'sa_pm', '1'),
('7', 'di_am', '1'),
('14', 'di_pm', '1')";
mysqli_query($bdd,$hordemis_insert);
?>