<?php
// UPLOAD DU FICHIER CSV, vérification et insertion en BASE

if(isset($_SESSION['user_droits'])) {
	if($_SESSION['user_droits'][5]!="2")
	{
		echo '<p class="noaccess">Vous n\'avez pas accès à ce module.<br><a href="../index.php">Accueil</a>.</p>';
	}

	else {
		$mimes = array('text/csv',
		'text/plain',
		'application/csv',
		'text/comma-separated-values',
		'application/excel',
		'application/vnd.ms-excel',
		'application/vnd.msexcel',
		'text/anytext',
		'application/octet-stream',
		'application/txt',);	
		if(@in_array($_FILES['file']['type'],$mimes)||isset($_POST['confirmmajdiv'])) {
			if(@in_array($_FILES['file']['type'],$mimes)) {
				mysqli_query($bdd,"DELETE FROM ".$prefix."_elevesmaj");
				// Recherche de l'encodage
				$content = file_get_contents($_FILES['file']['tmp_name']);
				$enclist = array(
	            'UTF-8', 'ASCII',
	            'ISO-8859-1', 'ISO-8859-2', 'ISO-8859-3', 'ISO-8859-4', 'ISO-8859-5',
	            'ISO-8859-6', 'ISO-8859-7', 'ISO-8859-8', 'ISO-8859-9', 'ISO-8859-10',
	            'ISO-8859-13', 'ISO-8859-14', 'ISO-8859-15', 'ISO-8859-16',
	            'Windows-1251', 'Windows-1252', 'Windows-1254',
	            );
				$encodage = mb_detect_encoding($content,$enclist,TRUE);
				if (mb_detect_encoding($content, $enclist, TRUE)==FALSE) {
					echo '<p class="signal">Ce fichier est mal encodé. Convertissez le par exemple en UTF-8.</p>';
				}
				// Si l'encodage est gérable
				else {
					if('UTF-8' != mb_detect_encoding($content, 'UTF-8', TRUE)) {
						$encoding=1; } else { $encoding=0; }
					// Intégration dans la table ".$prefix."_elevesmaj
					echo '<h1>Intégration des élèves dans la base de données...</h1>';
					if (($handle = fopen($_FILES['file']['tmp_name'], "r")) !== FALSE) {
						$id = 1;
						while (($data = fgetcsv($handle, 1000, ";")) !== FALSE) {
							if($encoding==1) {
								$att0 = mb_convert_encoding(mysqli_real_escape_string($bdd,$data[0]),"UTF-8",$encodage);
								$att1 = mb_convert_encoding(mysqli_real_escape_string($bdd,$data[1]),"UTF-8",$encodage);
								$att2 = mb_convert_encoding(mysqli_real_escape_string($bdd,$data[2]),"UTF-8",$encodage);
								if(isset($data[5])) {
									$att5 = mb_convert_encoding(mysqli_real_escape_string($bdd,$data[5]),"UTF-8",$encodage); 
								}
							}
							else {
								$att0 = mysqli_real_escape_string($bdd,$data[0]);
								$att1 = mysqli_real_escape_string($bdd,$data[1]);
								$att2 = mysqli_real_escape_string($bdd,$data[2]);
								if(isset($data[5])) {
									$att5 = mysqli_real_escape_string($bdd,$data[5]);
								}
							}
							if(!isset($data[5])) { $att5 = ""; }
							$att3 = mysqli_real_escape_string($bdd,$data[3]);
								$jour = strtolower($att3);
								$jour = substr("$att3", 0, 2);
								$mois = strtolower($att3);
								$mois = substr("$att3", 3, 2);
								$annee = strtolower($att3);
								$annee = substr("$att3", 6, 4);
							$att4 = mysqli_real_escape_string($bdd,$data[4]);
							
							$mdp = mb_strtolower(substr($att1,0,1),'UTF-8').$jour.$mois.$annee;
							mysqli_query($bdd,"INSERT INTO ".$prefix."_elevesmaj (eleves_id, nom, prenom, division, naissance, sexe, code, mdp) VALUES ('".$id."', '".$att0."', '".$att1."', '".$att2."', '".$annee."-".$mois."-".$jour."', '".$att4."', '".$att5."', PASSWORD('".$mdp."'))");
							
							$id++;
						}
						fclose($handle);
					}
				}
			}
				
			// Vérification de la qualité de la table de MAJ
			$elevescheck = mysqli_query($bdd,"SELECT * FROM ".$prefix."_elevesmaj WHERE nom = '' OR prenom = '' OR division = '' OR division LIKE '%  %' OR sexe = '' OR naissance ='0000-00-00' OR naissance = ''");
			$nb = mysqli_num_rows($elevescheck);
			if($nb>50) {
				echo '<p class="signal">Votre fichier contient beaucoup de problèmes. Vérifiez peut-être l\'ordre des données, le nombre de données...</p><p>';
				mysqli_query($bdd,"DELETE FROM ".$prefix."_elevesmaj");
				echo '</p><p class="signal">Aucune mise à jour n\'a été effectuée.<br>Corrigez votre fichier et refaîtes la procédure.</p>';
			}
			else if($nb>0) {
				echo '<p class="signal">Votre fichier contient les problèmes suivants :</p><p>';
				foreach($elevescheck as $problemes) {
					if($problemes['nom']=='Nom'||$problemes['nom']=='nom'||$problemes['nom']=='Nom de famille'||$problemes['nom']=='nom de famille') {
						echo 'La première ligne d\'entête doit être supprimée.<br>';
					}
					else {
						echo 'Il manque des informations pour '.$problemes['prenom'].' '.$problemes['nom'].' :';
						if($problemes['division']=='') { echo ' la division'; }
						if(preg_match('#  #', $problemes['division'])) { echo ' la division (ne doit pas contenir d\'espaces doublés)'; }
						if($problemes['sexe']=='') { echo ' le sexe'; }
						if($problemes['naissance']=='0000-00-00'||$problemes['naissance']=='') { echo ' la date de naissance'; }
						echo '.<br>';
					}
				}
				mysqli_query($bdd,"DELETE FROM ".$prefix."_elevesmaj");
				echo '</p><p class="signal">Aucune mise à jour n\'a été effectuée.<br>Corrigez votre fichier et refaîtes la procédure.</p>';
			}
			else {
				// Vérification des divisions
				$nb_equal_divs = 0;
				$elevescheck = mysqli_query($bdd,"SELECT * FROM ".$prefix."_elevesmaj");
				if(!isset($_POST['confirmmajdiv'])) {
					foreach($elevescheck as $checkdivs) {
						$nb_equal_divs += mysqli_num_rows(mysqli_query($bdd,"SELECT division FROM ".$prefix."_eleves WHERE division = '".$checkdivs['division']."'"));
					}
				}
				if($nb_equal_divs == 0&&!isset($_POST['confirmmajdiv'])) {
					echo '<p class="signal">Aucune division ne correspond à une division de l\'année précédente.<br>Peut-être faut-il formater les intitulés des divisions.</p><form method="POST" action="database.php?page=maj" name="confirmmaj"><input name="maj_send" type="hidden" value="stopdiv" /><input name="confirmmajdiv" class="bouton boutdb" type="submit" value="Faire quand même la mise à jour" /> <input name="supprmajdiv" class="bouton boutdb" type="submit" value="Abandonner la mise à jour" /></form>';
				}
				else {
					// Mise à jour depuis ".$prefix."_elevesmaj vers ".$prefix."_eleves
					$elevesmaj = mysqli_query($bdd,"SELECT * FROM ".$prefix."_elevesmaj");
					$eleves = mysqli_query($bdd,"SELECT * FROM ".$prefix."_eleves");
					
					// cas d'une base initialement installée sans date de naissance : 
					$badbase = mysqli_query($bdd,"SELECT * FROM ".$prefix."_eleves WHERE naissance ='0000-00-00' OR naissance = ''");
					$badbase_nb = mysqli_num_rows($badbase);
						
					// Trois opérations :
					
					// 1. Mise à jour (update) quand la ligne existe dans les deux tables
					
					while($elevesmaj_info=mysqli_fetch_assoc($elevesmaj)) {
						$majnom = mysqli_real_escape_string($bdd,$elevesmaj_info['nom']);
						$majprenom = mysqli_real_escape_string($bdd,$elevesmaj_info['prenom']);
						$majdiv = mysqli_real_escape_string($bdd,$elevesmaj_info['division']);
						$majnaissance = mysqli_real_escape_string($bdd,$elevesmaj_info['naissance']);
						$majsexe = mysqli_real_escape_string($bdd,$elevesmaj_info['sexe']);
						$majcode = mysqli_real_escape_string($bdd,$elevesmaj_info['code']);

					// 2. Ajout (insert) quand la ligne n'existe que dans elevesmaj
					
						if($badbase_nb>0) {
							$elevesold_select = "SELECT * FROM ".$prefix."_eleves WHERE nom='".$majnom."' AND prenom='".$majprenom."'";
						}
						// sinon (base avec dates de naissance) :
						else {
							$elevesold_select = "SELECT * FROM ".$prefix."_eleves WHERE nom='".$majnom."' AND prenom='".$majprenom."' AND naissance='".$elevesmaj_info['naissance']."'";
						}
						$elevesold = mysqli_query($bdd,$elevesold_select);
						$elevesold_nb = mysqli_num_rows($elevesold);
						
						if($elevesold_nb == 0)
						{
							// on intègre l'élève
							$mdp = mb_strtolower(substr($majprenom,0,1),'UTF-8').substr($majnaissance,8,2).substr($majnaissance,5,2).substr($majnaissance,0,4);
							$elevesnew = mysqli_query($bdd,"INSERT INTO ".$prefix."_eleves (eleves_id, nom, prenom, division, naissance, sexe, code, mdp) VALUES('', '".$majnom."', '".$majprenom."', '".$majdiv."', '".$majnaissance."', '".$majsexe."', '".$majcode."', PASSWORD('".$mdp."'))");
						}
						else {
							// on update l'élève :
							if($badbase_nb>0) {
								$mdp = mb_strtolower(substr($majprenom,0,1),'UTF-8').substr($majnaissance,8,2).substr($majnaissance,5,2).substr($majnaissance,0,4);
								$elevesup_update = "UPDATE ".$prefix."_eleves SET division='" .$majdiv. "', sexe='".$majsexe."', naissance='".$majnaissance."', mdp = PASSWORD('".$mdp."') WHERE nom='".$majnom."' AND prenom='".$majprenom."'";
								if(isset($_POST['newcode'])) {
									if($majcode!="") {
										$code_update = "UPDATE ".$prefix."_eleves SET code='" .$majcode. "' WHERE nom='".$majnom."' AND prenom='".$majprenom."'";
									}
								}
							}
							else {
								$elevesup_update = "UPDATE ".$prefix."_eleves SET division='" .$majdiv. "' WHERE nom='".$majnom."' AND prenom='".$majprenom."' AND naissance='".$elevesmaj_info['naissance']."'";
								if(isset($_POST['newcode'])) {
									if($majcode!="") {
										$code_update = "UPDATE ".$prefix."_eleves SET code='" .$majcode. "' WHERE nom='".$majnom."' AND prenom='".$majprenom."' AND naissance='".$elevesmaj_info['naissance']."'";
									}
								}
							}
							mysqli_query($bdd,$elevesup_update);
							if(isset($_POST['newcode'])) {
								if($majcode!="") {
									mysqli_query($bdd,$code_update);
								}
							}
							// purge des évaluations n-3 :
							$elevetoclean = mysqli_query($bdd,"SELECT eleves_id, division FROM ".$prefix."_eleves WHERE nom='".$majnom."' AND prenom='".$majprenom."' AND naissance='".$elevesmaj_info['naissance']."'");
							$elevetoclean_info = mysqli_fetch_assoc($elevetoclean);
							if(substr($elevetoclean_info['division'],0,1)=="3") {
								$savtoclean = mysqli_query($bdd,"SELECT * FROM ".$prefix."_savele WHERE eleves_id = '".$elevetoclean_info['eleves_id']."' AND (s_id LIKE 'APD6%' OR s_id LIKE 'EMI6%' OR s_id LIKE 'PER6%')");
								$savtoclean_nb = mysqli_num_rows($savtoclean);
								if($savtoclean_nb!=0) {
									mysqli_query($bdd,"DELETE FROM ".$prefix."_savele WHERE eleves_id = '".$elevetoclean_info['eleves_id']."' AND (s_id LIKE 'APD6%' OR s_id LIKE 'EMI6%' OR s_id LIKE 'PER6%')"); 
								}
							}
							if(substr($elevetoclean_info['division'],0,1)=="2") {
								$savtoclean = mysqli_query($bdd,"SELECT * FROM ".$prefix."_savele WHERE eleves_id = '".$elevetoclean_info['eleves_id']."' AND (s_id LIKE 'APD5%' OR s_id LIKE 'EMI5%' OR s_id LIKE 'PER5%')");
								$savtoclean_nb = mysqli_num_rows($savtoclean);
								if($savtoclean_nb!=0) {
									mysqli_query($bdd,"DELETE FROM ".$prefix."_savele WHERE eleves_id = '".$elevetoclean_info['eleves_id']."' AND (s_id LIKE 'APD5%' OR s_id LIKE 'EMI5%' OR s_id LIKE 'PER5%')"); 
								}
							}
							if(substr($elevetoclean_info['division'],0,1)=="1") {
								$savtoclean = mysqli_query($bdd,"SELECT * FROM ".$prefix."_savele WHERE eleves_id = '".$elevetoclean_info['eleves_id']."' AND (s_id LIKE 'APD4%' OR s_id LIKE 'EMI4%' OR s_id LIKE 'PER4%')");
								$savtoclean_nb = mysqli_num_rows($savtoclean);
								if($savtoclean_nb!=0) {
									mysqli_query($bdd,"DELETE FROM ".$prefix."_savele WHERE eleves_id = '".$elevetoclean_info['eleves_id']."' AND (s_id LIKE 'APD4%' OR s_id LIKE 'EMI4%' OR s_id LIKE 'PER4%')"); 
								}
							}
							if(substr($elevetoclean_info['division'],0,1)=="t") {
								$savtoclean = mysqli_query($bdd,"SELECT * FROM ".$prefix."_savele WHERE eleves_id = '".$elevetoclean_info['eleves_id']."' AND (s_id LIKE 'APD3%' OR s_id LIKE 'EMI3%' OR s_id LIKE 'PER3%')");
								$savtoclean_nb = mysqli_num_rows($savtoclean);
								if($savtoclean_nb!=0) {
									mysqli_query($bdd,"DELETE FROM ".$prefix."_savele WHERE eleves_id = '".$elevetoclean_info['eleves_id']."' AND (s_id LIKE 'APD3%' OR s_id LIKE 'EMI3%' OR s_id LIKE 'PER3%')"); 
								}
							}
						}			
					}

					// 3. Suppression (delete) quand la ligne n'existe que dans eleves
					
					while($eleves_info = mysqli_fetch_assoc($eleves)) {
						$nom = mysqli_real_escape_string($bdd,$eleves_info['nom']);
						$prenom = mysqli_real_escape_string($bdd,$eleves_info['prenom']);
						$div = mysqli_real_escape_string($bdd,$eleves_info['division']);
						if($badbase_nb>0) {
							$elevesnew_select = "SELECT * FROM ".$prefix."_elevesmaj WHERE nom='".$nom."' AND prenom='".$prenom."'";
						}
						else {
							$elevesnew_select = "SELECT * FROM ".$prefix."_elevesmaj WHERE nom='".$nom."' AND prenom='".$prenom."' AND naissance='".$eleves_info['naissance']."'";
						}
						$elevesnew = mysqli_query($bdd,$elevesnew_select);
						$elevesnew_nb = mysqli_num_rows($elevesnew);
						
						if($elevesnew_nb == 0)
						{
							// on supprime l'élève
							$elevestosup = mysqli_query($bdd,"SELECT * FROM ".$prefix."_eleves WHERE nom='".$nom."' AND prenom='".$prenom."' AND naissance='".$eleves_info['naissance']."'");
							$elevestosup_info = mysqli_fetch_assoc($elevestosup);
							$elevestosup_id = $elevestosup_info['eleves_id'];
							
							mysqli_query($bdd,"DELETE FROM ".$prefix."_eleves WHERE eleves_id='".$elevestosup_id."'");
							mysqli_query($bdd,"DELETE FROM ".$prefix."_savele WHERE eleves_id='".$elevestosup_id."'");
							mysqli_query($bdd,"DELETE FROM ".$prefix."_groupele WHERE eleves_id='".$elevestosup_id."'");
						}
					}

					// Puis vider la table elevesmaj
					mysqli_query($bdd,"DELETE FROM ".$prefix."_elevesmaj");
					
					// Mise à jour ou création des effectifs dans _etab_effectifs
					$anneesco = $_POST['annee_effectifs'];
					$divisions = mysqli_query($bdd,"SELECT division FROM ".$prefix."_eleves GROUP BY division ORDER BY division ASC");
					if(mysqli_num_rows($divisions)>0) {
						$etab = mysqli_query($bdd,"SELECT etab_id FROM ".$prefix."_etab");
						if(mysqli_num_rows($etab)>0) {
							$etab_info = mysqli_fetch_assoc($etab);
							$etab_id = $etab_info['etab_id'];
						}
						else { $etab_id = ''; }
						foreach($divisions as $div) {
							$nbeleves = mysqli_num_rows(mysqli_query($bdd,"SELECT * FROM ".$prefix."_eleves WHERE division = '".$div['division']."'"));
							if(mysqli_num_rows(mysqli_query($bdd,"SELECT * FROM ".$prefix."_etab_effectifs WHERE anneesco = '".$anneesco."' AND division = '".$div['division']."'"))>0) {
								mysqli_query($bdd,"UPDATE ".$prefix."_etab_effectifs SET effectif = '".$nbeleves."' WHERE anneesco = '".$anneesco."' AND division = '".$div['division']."'");
							}
							else {
								mysqli_query($bdd,"INSERT INTO ".$prefix."_etab_effectifs (etab_id, anneesco, division, effectif) VALUES ('".$etab_id."', '".$anneesco."', '".$div['division']."', '".$nbeleves."')");
							}
						}
					}
					$_SESSION['import']="maj";
					echo '<script language="Javascript">
					<!--
					document.location.replace("database.php?page=consulter");
					// -->
					</script>';
				}
			}
		}
		else {
			die("Ce n'est pas un fichier de type .csv");
		}
	}
}
else {
	include('include/noaccess.php');
	echo '<br><a href="../index.php">Accueil</a>.</p>';
}
?>
