<?php
echo '<meta charset="utf-8" />';
if(isset($_SESSION['user_droits'])) {
	if($_SESSION['user_droits'][4]!="2")
	{
		echo '<p class="noaccess">Vous n\'avez pas accès à ce module.<br><a href="./index.php">Accueil</a></p>';
	}
	else {
				
		//MISES A JOUR
		
		echo '<h1>Mises à jour</h1>';
		
		$url = "https://infodoclog.iddocs.fr/log/version.txt";
		$vers_offbdd = "";
		$vers_offic = "";
		$vers_offurl = @htmlspecialchars(implode('', file($url)));
		$vers_offbdd = @substr($vers_offurl, 5, 4);
		$vers_offic = @substr($vers_offurl, 0, 4);
						
		echo '<h2>Logiciel</h2>';
		$versin = mysqli_query($bdd,"SELECT valeur FROM ".$prefix."_parametres WHERE param_nom = 'version_log'");
		$versin_info = mysqli_fetch_assoc($versin);
		echo '<p>Vous utilisez la version '.$versin_info['valeur'].' du logiciel.</p>';

		if($vers_offic=="") {
			echo '<p><i>Vérification impossible de mises à jour hors connexion.</i></p>';
		}
		else if($vers_offic > $versin_info['valeur']) {
			echo '<p><b>Nouvelle version disponible : ';
			$vers_aff = substr($vers_offic,2,2);
			echo ''.$vers_offic.'</b></p>';
			echo '<p class="maxwidth">Pour mettre à jour Infodoclog, téléchargez la mise à jour qui vous correspond au format ZIP et déposer les fichiers sur votre serveur (via FTP). En cas de doute, téléchargez la version complète du logiciel au format ZIP et déposer les fichiers sur votre serveur (via FTP).<br /><b>Il est conseillé de sauvegarder la base de données avant d\'effectuer une mise à jour.</b></p>';
			// Recherche d'une mise à jour en montée de version
			$url = "https://infodoclog.iddocs.fr/log/versmaj.txt";
			$vers_offurl = @htmlspecialchars(implode('', file($url)));
			if (preg_match("/\b".$versin_info['valeur']."\b/i",$vers_offurl,$trouve)) {
				echo '<p class="maxwidth"><a href="http://infodoclog.iddocs.fr/log/idlogmaj'.$versin_info['valeur'].'to'.$vers_offic.'.zip"><i class="fas fa-angle-double-right"></i> Mise à jour de '.$versin_info['valeur'].' vers '.$vers_offic.'</a>.</p>';
			}
			echo '<p class="maxwidth"><a href="http://infodoclog.iddocs.fr/log/idlog'.$vers_offic.'.zip"><i class="fas fa-angle-double-right"></i> Version complète de la version '.$vers_offic.'</a>.</p>';
		}

		echo '<h2>Base de données</h2>';
		if(isset($_POST['valmajbdd'])) {
			include('./db/maj_bdd.php');
		}
		if($dossier = opendir('./db/bddmaj')) {
			$versinb = mysqli_query($bdd,"SELECT valeur FROM ".$prefix."_parametres WHERE param_nom = 'version_bdd'");
			$versinb_info = mysqli_fetch_assoc($versinb);
			$i=0;
			while(false !== ($fichier = readdir($dossier))) {
				if($fichier != '.' && $fichier != '..') {
					$verscheck = substr($fichier,3,1).'.'.substr($fichier,4,2);
					if($verscheck>$versinb_info['valeur']) {
						$newb = number_format(($versinb_info['valeur']+0.01),2);
						echo '<p class="signal maxwidth"><b>Votre base de données ('.$versinb_info['valeur'].') n\'est pas à jour.</b></p><p style="color:#900;">Cette mise à jour, vers la version '.$verscheck.', est nécessaire pour le bon fonctionnement du logiciel.</p><p class="maxwidth">Pour la mise à jour de la base de données, suivez la procédure suivante :</p>';
						echo '<form method="POST" action="" name="majbadd"><p class="signal maxwidth"><input type="hidden" name="majbdd" value="'.substr($newb,0,1).substr($newb,2,2).'"><input class="bouton boutparam" type="submit" name="valmajbdd" id="majbdd" value="Passer de la version '.$versinb_info['valeur'].' à la version '.number_format(($versinb_info['valeur']+0.01),2).'" /></p></form>';
						$i++;
						break;
					}
				}
			}
		}
		if($i==0) { echo '<p>Base de données à jour : '.$versinb_info['valeur'].'</p>'; }
		if($i==0&&$vers_offic > $versin_info['valeur']) {
			echo '<p class="maxwidth">Si votre logiciel n\'est pas à jour, il est possible que la base de données ne soit pas à jour.<br>Mettez à jour le logiciel !</p>';
		}
		
		//SAUVEGARDE
		echo '<h1>Sauvegarde de la base de données</h1>';
		if(isset($_POST['savetabs'])) { include('./db/backup.php'); }
		echo '<p><form method="POST" name="savetabs" action="">Validez ci-dessous pour sauvegarder la base de données au format SQL</a></p>';
		echo '<p><a style="color:black;text-decoration:none;" onmouseover="this.style.textDecoration=\'underline\';" onmouseout="this.style.textDecoration=\'none\';" onmousedown="toggleDiv(\'divtables\');"><b>Choisir les tables à sauvegarder</b></a></p>';
		echo '<div  id="divtables" style="display:none;">';
		echo '<input id="checkAll" type="checkbox" checked />Tout cocher ou décocher<br>';
		echo '<script type=\'text/javascript\'>
			$(\'#checkAll\').click(function() {

			var elevs = $("#tables").find(\':checkbox\'); 
			   if(this.checked){ 
				  elevs.prop(\'checked\', true); 
			   }else{ 
				  elevs.prop(\'checked\', false);
			   }          
			});
		</script>';
		echo '<ul id="tables">';
		$result_tables = mysqli_query($bdd,"SHOW TABLE STATUS LIKE '".$prefix."_%'");
		$_SESSION['nb_tables'] = mysqli_num_rows($result_tables);
		if($result_tables && $result_tables->num_rows) {
			while($obj_table = mysqli_fetch_assoc($result_tables)) {
				echo '<input type="checkbox" id="'.$obj_table['Name'].'" name="'.$obj_table['Name'].'" checked /> <label for="'.$obj_table['Name'].'">'.$obj_table['Name'].'</label><br>';
			}
		}
		echo '</ul></div>';
		echo '<input class="bouton boutparam" type="submit" name="savetabs" value="Sauvegarder" /></form>';
		echo '<h2>Liste des sauvegardes effectuées :</h2>';
		if(isset($_POST['restaure'])) { include('./db/restaure.php'); }
		if($dossier = opendir('./db/backup')) {
			$tab_save = array();
			echo '<ul>';
			$i=1;
			while(false !== ($fichier = readdir($dossier))) {
				if($fichier != '.' && $fichier != '..') {
					if(substr($fichier,22,3)=="par") {
						$typepar = 'Cette sauvergarde est partielle. <br>La restauration doit être exceptionnelle et suppose que toutes les données actuelles contenues dans les tables sauvegardées seront supprimées.';
					}
					else {
						$typepar = 'Cette sauvegarde est totale.<br>La restauration doit être exceptionnelle et suppose que toutes les données contenues dans toutes les tables seront supprimées.';
					}
					$line = '<li><a href="./db/backup/' . $fichier . '">' . $fichier . '</a> (<a style="color:black;text-decoration:none;" onmouseover="this.style.textDecoration=\'underline\';" onmouseout="this.style.textDecoration=\'none\';" onmousedown="toggleDiv(\'divrestaure'.$i.'\');">restaurer cette sauvegarde</a>)</li>
						<div id="divrestaure'.$i.'" style="display:none;"><p class="signal maxwidth">Cette sauvegarde date du '.substr($fichier,12,2).'/'.substr($fichier,10,2).'/'.substr($fichier,6,4).', à '.substr($fichier,15,2).'h'.substr($fichier,17,2).'. '.$typepar.' Il peut y avoir ensuite des problèmes si jamais la restauration provient d\'une version antérieure d\'<i>InfodocLog</i>, en particulier pour les paramétrages. Il est conseillé d\'effectuer une sauvegarde de l\'installation actuelle avant de restaurer une autre sauvegarde, par sécurité.</p><form name="restaure" method="POST" action=""><input type="hidden" value="'.$fichier.'" name="fichier'.$i.'" />Confirmer la restauration de '.$fichier.' : <input class="bouton boutparam" type="submit" name="restaure" value="Valider" /></form><br></div>';
					array_push ($tab_save,$line);
					$i++;
				}
			}
			arsort($tab_save);
			$count = count($tab_save);
			if($count==0){
				echo '<p>Aucune sauvegarde.</p>';
			}
			else {
				rsort($tab_save);
				for($i=0;$i<$count;$i++) {
					echo $tab_save[$i];
				}
			}
			echo '</ul>';
			closedir($dossier);
		}
	}
}
else {
	include('include/noaccess.php');
	echo '<br><a href="./index.php">Accueil</a></p>';
}
?>
