<?php
function suppr_accents($str, $charset='utf-8')
{
    $str = htmlentities($str, ENT_NOQUOTES, $charset);
    
    $str = preg_replace('#&([A-za-z])(?:acute|cedil|caron|circ|grave|orn|ring|slash|th|tilde|uml);#', '\1', $str);
    $str = preg_replace('#&([A-za-z]{2})(?:lig);#', '\1', $str); // pour les ligatures e.g. '&oelig;'
    $str = preg_replace('#&[^;]+;#', '', $str); // supprime les autres caractères
    
    return $str;
}
function suppr_accentss($str, $charset='utf-8')
{
	$str = strtr(
    $str, 
    '@ÀÁÂÃÄÅÇÈÉÊËÌÍÎÏÒÓÔÕÖÙÚÛÜÝàáâãäåçèéêëìíîïðòóôõöùúûüýÿ',
    'aAAAAAACEEEEIIIIOOOOOUUUUYaaaaaaceeeeiiiioooooouuuuyy');
    return $str;
}
/*function wd_unaccent_compare($a, $b)
{
    return strcmp(wd_remove_accents($a), wd_remove_accents($b));
}*/
$tabEleves = array();
$eleves_select = "SELECT * FROM ".$prefix."_eleves ORDER BY 
	replace(replace(replace(replace(replace(replace(replace(replace(replace(replace(replace(replace(
	replace(replace(replace(replace(replace(replace(replace(replace(replace(replace(replace(replace(
	replace(nom,'À','A'),'Á','A'),'Â','A'),'Ã','A'),'Ä','A'),'Å','A'),'Ç','C'),'È','E'),'É','E')
	,'Ê','E'),'Ë','E'),'Ì','I'),'Í','I'),'Î','I'),'Ï','I'),'Ò','O'),'Ó','O'),'Ô','O'),'Õ','O')
	,'Ö','O'),'Ù','U'),'Ú','U'),'Û','U'),'Ü','U'),'Ý','Y')";
// requete sql à personnaliser pour correspondre à votre base de données
$result = mysqli_query($bdd,$eleves_select);
if($result) {
	// on parcourt les resultats
	while ($ligne = mysqli_fetch_assoc($result)) {
		// on affiche les resultats dans un element de liste en ajoutant 
		// la fonction fill sur l'evenenement onClick
		$nom = stripslashes(mysqli_real_escape_string($bdd,$ligne['nom']));
		$prenom = stripslashes(mysqli_real_escape_string($bdd,$ligne['prenom']));
		$div = mysqli_real_escape_string($bdd,$ligne['division']);
		$eleve = $nom.', '.$prenom.' ('.$div.')';
		array_push($tabEleves, $eleve);
	}			
} else {
	echo 'Il y a un probleme avec la requete sql.';
}
?>
<script>
$( function() {
    var accentMap = {
      'é':'e','è':'e','ê':'e','ë':'e','à':'a','â':'a',
      'î':'i','ï':'i','ô':'o','ö':'o','ù':'u','û':'u',
	  'É':'e','È':'e','Ê':'e','Ë':'e','À':'a','Â':'a',
	  'Î':'i','Ï':'i','Ô':'o','Ö':'o','Ù':'u','Û':'u'
    };
    var normalize = function( term ) {
      var ret = "";
      for ( var i = 0; i < term.length; i++ ) {
        ret += accentMap[ term.charAt(i) ] || term.charAt(i);
      }
      return ret;
    };

	$( "#eleves" ).autocomplete({
	  source: function( request, response ) {
        var matcher = new RegExp( "^" + $.ui.autocomplete.escapeRegex( request.term ), "i" );
        response( $.grep( <?php echo json_encode($tabEleves) ?>, function( value ) {
          value = value.label || value.value || value;
          return matcher.test( value ) || matcher.test( normalize( value ) );
        }) );
      }
    });
  } );
</script>
<script>
$( function() {
    var accentMap = {
      'é':'e','è':'e','ê':'e','ë':'e','à':'a','â':'a',
      'î':'i','ï':'i','ô':'o','ö':'o','ù':'u','û':'u',
    'É':'e','È':'e','Ê':'e','Ë':'e','À':'a','Â':'a',
    'Î':'i','Ï':'i','Ô':'o','Ö':'o','Ù':'u','Û':'u'
    };
    var normalize = function( term ) {
      var ret = "";
      for ( var i = 0; i < term.length; i++ ) {
        ret += accentMap[ term.charAt(i) ] || term.charAt(i);
      }
      return ret;
    };

  $( "#elevesbis" ).autocomplete({
    source: function( request, response ) {
        var matcher = new RegExp( "^" + $.ui.autocomplete.escapeRegex( request.term ), "i" );
        response( $.grep( <?php echo json_encode($tabEleves) ?>, function( value ) {
          value = value.label || value.value || value;
          return matcher.test( value ) || matcher.test( normalize( value ) );
        }) );
      }
    });
  } );
</script>